import { ComputedRef, InjectionKey } from "@vue/composition-api";

export interface LbToken {
  access_token: string;
  exp: number;
  fromTime: number;
  username: string;
}

export interface LbAuthService {
  loading: ComputedRef<boolean>;
  ready: ComputedRef<boolean>;
  authorization: ComputedRef<string | null>;
  username: ComputedRef<string>;
  createLoginUrl(): string;
  login(credentials: { username: string; password: string }, remember: boolean): Promise<boolean>;
  logout(): Promise<void>;
}

export const LbAuthServiceKey: InjectionKey<LbAuthService> = Symbol("LbAuthService");
