/* eslint-disable */ 
export type Maybe<T> = T | null;
export type Exact<T extends { [key: string]: unknown }> = { [K in keyof T]: T[K] };
export type MakeOptional<T, K extends keyof T> = Omit<T, K> & { [SubKey in K]?: Maybe<T[SubKey]> };
export type MakeMaybe<T, K extends keyof T> = Omit<T, K> & { [SubKey in K]: Maybe<T[SubKey]> };
/** All built-in and custom scalars, mapped to their actual values */
export interface Scalars {
  ID: string;
  String: string;
  Boolean: boolean;
  Int: number;
  Float: number;
  Cursor: string;
  Date: string;
  Datetime: string;
  Real: string;
  Serial: string;
  Text: string;
  Time: string;
  Year: number;
}








/** The result of the delte bulk mutation. */
export interface GqlDeleteBulkResult {
  /** The total count of objects returned by the page options that has been deleted. */
  deleted: Scalars['Int'];
}

/** The result of the delete mutation. */
export interface GqlDeleteResult {
  /**
   * A boolean indicating if the current operation
   * has caused the deletion of the object.
   * This means that in case of non existing object this value will be false.
   */
  deleted: Scalars['Boolean'];
}

export interface GqlEntityID {
  entityName: GqlEntityName;
  _id: Scalars['ID'];
}

export enum GqlEntityName {
  Todo = 'Todo',
  _User = '_User'
}

export interface GqlFileInfo {
  fileId: Scalars['ID'];
  mimeType: Scalars['String'];
  name: Scalars['String'];
  size: Scalars['Int'];
  uploadedOn: Scalars['Datetime'];
  link: Scalars['String'];
}


export interface GqlFileInfouploadedOnArgs {
  format?: Maybe<Scalars['String']>;
}

/** Options to configure the list of Issue (only for issueLevel=WARNING) to be returned by a mutation service. */
export interface GqlForceWarnings {
  actionVeto?: Maybe<Scalars['Boolean']>;
  dataValidation?: Maybe<Scalars['Boolean']>;
}

export interface GqlFormActionHandlerMessageResult {
  type: GqlMessageType;
  title?: Maybe<Scalars['String']>;
  message: Scalars['String'];
}

export interface GqlFormActionHandlerResult {
  type: GqlFormActionHandlerResultType;
  message?: Maybe<GqlFormActionHandlerMessageResult>;
}

export enum GqlFormActionHandlerResultType {
  NONE = 'NONE',
  MESSAGE = 'MESSAGE'
}

/**
 * The InsightType enum type is used to enable insight of the process of data retrieval.
 * This is useful for example to get the execution time of the query resolved by the server.
 * Use only in debug to identify possible bottlenecks.
 */
export enum GqlInsightType {
  /**
   * Enable a light insight, that doesn't add a big overhead on performances
   * but its information can be incomplete.
   * The returned informations include the number of queries, their configuration,
   * and the times needed to perform them.
   */
  LIGHT = 'LIGHT',
  /**
   * Enable a full insight, that returns all the information about the executed queries.
   * Can add a significant overhead due to the quantity of data retrieved.
   * Include all the informations of LIGHT, alongside the SQL queries
   * actually executed and their EXPLAIN.
   */
  FULL = 'FULL'
}

export interface GqlIssue {
  sourceRequestReference: Scalars['String'];
  userMessage: Scalars['String'];
  issueLevel: GqlIssueLevel;
  issueReferenceType?: Maybe<GqlIssueReferenceType>;
  issueType: GqlIssueType;
  entityID?: Maybe<Scalars['ID']>;
  _clientId?: Maybe<Scalars['ID']>;
  entityName?: Maybe<Scalars['String']>;
  attributeNames?: Maybe<Array<Scalars['String']>>;
  roleNames?: Maybe<Array<Scalars['String']>>;
  applicationName: Scalars['String'];
  profileName: Scalars['String'];
  traceId: Scalars['String'];
}

export enum GqlIssueLevel {
  ERROR = 'ERROR',
  WARNING = 'WARNING'
}

export enum GqlIssueReferenceType {
  ENTITY = 'ENTITY',
  ENTITY_ROLE = 'ENTITY_ROLE',
  ENTITY_ATTRIBUTE = 'ENTITY_ATTRIBUTE'
}

export enum GqlIssueType {
  SERVER_ERROR = 'SERVER_ERROR',
  MALFORMED_REQUEST = 'MALFORMED_REQUEST',
  DATA_TYPE = 'DATA_TYPE',
  ENTITY_GRANT_CREATE = 'ENTITY_GRANT_CREATE',
  ENTITY_GRANT_EDIT = 'ENTITY_GRANT_EDIT',
  ENTITY_GRANT_DELETE = 'ENTITY_GRANT_DELETE',
  ENTITY_GRANT_READ = 'ENTITY_GRANT_READ',
  ROLE_GRANT_CREATE = 'ROLE_GRANT_CREATE',
  ROLE_GRANT_EDIT = 'ROLE_GRANT_EDIT',
  ROLE_GRANT_DELETE = 'ROLE_GRANT_DELETE',
  ROLE_GRANT_READ = 'ROLE_GRANT_READ',
  ATTRIBUTE_GRANT_EDIT = 'ATTRIBUTE_GRANT_EDIT',
  ATTRIBUTE_GRANT_READ = 'ATTRIBUTE_GRANT_READ',
  SERVICE_HANDLER_ERROR = 'SERVICE_HANDLER_ERROR',
  ENTITY_LOCK_EDIT = 'ENTITY_LOCK_EDIT',
  ENTITY_LOCK_PERSIST = 'ENTITY_LOCK_PERSIST',
  ENTITY_NOT_FOUND = 'ENTITY_NOT_FOUND',
  ENTITY_ATTRIBUTE_NOT_FOUND = 'ENTITY_ATTRIBUTE_NOT_FOUND',
  ENTITY_ROLE_NOT_FOUND = 'ENTITY_ROLE_NOT_FOUND',
  ENTITY_ACCESS_FORBIDDEN = 'ENTITY_ACCESS_FORBIDDEN',
  ENTITY_ATTRIBUTE_ACCESS_FORBIDDEN = 'ENTITY_ATTRIBUTE_ACCESS_FORBIDDEN',
  ENTITY_ROLE_ACCESS_FORBIDDEN = 'ENTITY_ROLE_ACCESS_FORBIDDEN',
  APPLICATION_ACCESS_FORBIDDEN = 'APPLICATION_ACCESS_FORBIDDEN',
  ENTITY_DOMAIN = 'ENTITY_DOMAIN',
  ENTITY_UNIQUE = 'ENTITY_UNIQUE',
  ROLE_CARDINALITY = 'ROLE_CARDINALITY',
  ROLE_DOMAIN = 'ROLE_DOMAIN',
  ATTRIBUTE_REQUIRED = 'ATTRIBUTE_REQUIRED',
  ATTRIBUTE_RANGE = 'ATTRIBUTE_RANGE',
  ATTRIBUTE_REAL_DECIMAL_DIGITS = 'ATTRIBUTE_REAL_DECIMAL_DIGITS',
  ATTRIBUTE_STRING_LENGTH = 'ATTRIBUTE_STRING_LENGTH',
  ATTRIBUTE_STRING_PATTERN = 'ATTRIBUTE_STRING_PATTERN',
  ATTRIBUTE_FILE_TYPE = 'ATTRIBUTE_FILE_TYPE',
  ATTRIBUTE_FILE_SIZE = 'ATTRIBUTE_FILE_SIZE',
  ATTRIBUTE_CODICE_FISCALE_PERSONA_FISICA = 'ATTRIBUTE_CODICE_FISCALE_PERSONA_FISICA',
  ATTRIBUTE_PARTITA_IVA = 'ATTRIBUTE_PARTITA_IVA',
  ATTRIBUTE_CODICE_FISCALE_PERSONA_GIURIDICA = 'ATTRIBUTE_CODICE_FISCALE_PERSONA_GIURIDICA',
  ATTRIBUTE_EMAIL = 'ATTRIBUTE_EMAIL',
  ATTRIBUTE_PHONE = 'ATTRIBUTE_PHONE',
  ENTITY_CREATE_VETO = 'ENTITY_CREATE_VETO',
  ENTITY_EDIT_VETO = 'ENTITY_EDIT_VETO',
  ENTITY_DELETE_VETO = 'ENTITY_DELETE_VETO'
}

/** The result of the lock and unlock services. */
export interface GqlLockStatusResult {
  locked: Scalars['Boolean'];
  minutes: Scalars['Int'];
}

export enum GqlMessageType {
  INFO = 'INFO',
  WARNING = 'WARNING',
  ERROR = 'ERROR'
}

/** Use a Mutation to create, update and delete data. */
export interface GqlMutation {
  /**
   * Create an object of class Todo.
   * Returns the newly created object.
   */
  Todo___create?: Maybe<GqlTodo>;
  /**
   * Create an object of class _User.
   * Returns the newly created object.
   */
  _User___create?: Maybe<Gql_User>;
  /**
   * Update an object of class Todo.
   * Returns the newly created object.
   */
  Todo___update?: Maybe<GqlTodo>;
  /**
   * Bulk update a set of objects of class Todo.
   * Returns an array of updated objects and a number representing the total count of items affected.
   */
  Todo___updateBulk?: Maybe<GqlTodoBulkResult>;
  /**
   * Update an object of class _User.
   * Returns the newly created object.
   */
  _User___update?: Maybe<Gql_User>;
  /**
   * Bulk update a set of objects of class _User.
   * Returns an array of updated objects and a number representing the total count of items affected.
   */
  _User___updateBulk?: Maybe<Gql_UserBulkResult>;
  /**
   * Create or update an object of class Todo.
   * Returns the newly created/updated object.
   */
  Todo___save?: Maybe<GqlTodo>;
  /**
   * Create or update an object of class _User.
   * Returns the newly created/updated object.
   */
  _User___save?: Maybe<Gql_User>;
  /**
   * Delete an object of class Todo.
   * Returns true if the object has been deleted succesfully.
   */
  Todo___delete?: Maybe<GqlDeleteResult>;
  /**
   * Bulk delete a set of objects of class Todo.
   * Returns the number of object successfully deleted.
   */
  Todo___deleteBulk?: Maybe<GqlDeleteBulkResult>;
  /**
   * Delete an object of class _User.
   * Returns true if the object has been deleted succesfully.
   */
  _User___delete?: Maybe<GqlDeleteResult>;
  /**
   * Bulk delete a set of objects of class _User.
   * Returns the number of object successfully deleted.
   */
  _User___deleteBulk?: Maybe<GqlDeleteBulkResult>;
  lock?: Maybe<GqlLockStatusResult>;
  unlock?: Maybe<GqlLockStatusResult>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutationTodo___createArgs {
  data: GqlTodoCreate;
  forceWarnings?: Maybe<GqlForceWarnings>;
  insight?: Maybe<GqlInsightType>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutation_User___createArgs {
  data: Gql_UserCreate;
  forceWarnings?: Maybe<GqlForceWarnings>;
  insight?: Maybe<GqlInsightType>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutationTodo___updateArgs {
  data: GqlTodoUpdate;
  forceWarnings?: Maybe<GqlForceWarnings>;
  insight?: Maybe<GqlInsightType>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutationTodo___updateBulkArgs {
  data: GqlTodoUpdateBulk;
  options: GqlTodoPageOptions;
  forceWarnings?: Maybe<GqlForceWarnings>;
  insight?: Maybe<GqlInsightType>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutation_User___updateArgs {
  data: Gql_UserUpdate;
  forceWarnings?: Maybe<GqlForceWarnings>;
  insight?: Maybe<GqlInsightType>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutation_User___updateBulkArgs {
  data: Gql_UserUpdateBulk;
  options: Gql_UserPageOptions;
  forceWarnings?: Maybe<GqlForceWarnings>;
  insight?: Maybe<GqlInsightType>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutationTodo___saveArgs {
  data: GqlTodoDraft;
  forceWarnings?: Maybe<GqlForceWarnings>;
  insight?: Maybe<GqlInsightType>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutation_User___saveArgs {
  data: Gql_UserDraft;
  forceWarnings?: Maybe<GqlForceWarnings>;
  insight?: Maybe<GqlInsightType>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutationTodo___deleteArgs {
  _id: Scalars['ID'];
  forceWarnings?: Maybe<GqlForceWarnings>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutationTodo___deleteBulkArgs {
  options: GqlTodoPageOptions;
  forceWarnings?: Maybe<GqlForceWarnings>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutation_User___deleteArgs {
  _id: Scalars['ID'];
  forceWarnings?: Maybe<GqlForceWarnings>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutation_User___deleteBulkArgs {
  options: Gql_UserPageOptions;
  forceWarnings?: Maybe<GqlForceWarnings>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutationlockArgs {
  locks: Array<GqlEntityID>;
  minutes?: Maybe<Scalars['Int']>;
}


/** Use a Mutation to create, update and delete data. */
export interface GqlMutationunlockArgs {
  locks: Array<GqlEntityID>;
}

/**
 * POST <cloudletUrl>/auth/file/{class}/{attribute}
 * GET  <cloudletUrl>/auth/file/{class}/{attribute}/pending/{pendingFileId}
 * GET  <cloudletUrl>/auth/file/{class}/ID/{attribute}
 */
export interface GqlPendingFileReference {
  pendingFileId: Scalars['String'];
  fileId: Scalars['ID'];
  mimeType: Scalars['String'];
  name: Scalars['String'];
  size: Scalars['Int'];
  uploadedOn: Scalars['Datetime'];
}

/** Use a Query to fetch data. */
export interface GqlQuery {
  /** Retrieve a single object of class Todo by ID. */
  Todo___get?: Maybe<GqlTodo>;
  /** Retrieve a collection of object of class Todo. */
  Todo___getPage?: Maybe<GqlTodoPage>;
  /** Retrieve a single object of class _User by ID. */
  _User___get?: Maybe<Gql_User>;
  /** Retrieve a collection of object of class _User. */
  _User___getPage?: Maybe<Gql_UserPage>;
  /** Retrieve a preview object of class Todo for an updated instance of Todo. */
  Todo___previewUpdate?: Maybe<GqlTodo>;
  /** Retrieve a preview object of class _User for an updated instance of _User. */
  _User___previewUpdate?: Maybe<Gql_User>;
  /**
   * Validation of an update on object of class Todo.
   * Returns a ValidationResult.
   */
  Todo___validateUpdate?: Maybe<GqlValidationResult>;
  /**
   * Validation of a bulk update on a set of objects of class Todo.
   * Returns a ValidationResult.
   */
  Todo___validateUpdateBulk?: Maybe<GqlValidationResult>;
  /**
   * Validation of an update on object of class _User.
   * Returns a ValidationResult.
   */
  _User___validateUpdate?: Maybe<GqlValidationResult>;
  /**
   * Validation of a bulk update on a set of objects of class _User.
   * Returns a ValidationResult.
   */
  _User___validateUpdateBulk?: Maybe<GqlValidationResult>;
  /**
   * Validation of a save on object of class Todo.
   * Returns a ValidationResult.
   */
  Todo___validate?: Maybe<GqlValidationResult>;
  /**
   * Validation of a save on object of class _User.
   * Returns a ValidationResult.
   */
  _User___validate?: Maybe<GqlValidationResult>;
  /** Retrieve a preview object of class Todo for an object of Todo not yet instanced. */
  Todo___preview?: Maybe<GqlTodo>;
  /** Retrieve a preview object of class _User for an object of _User not yet instanced. */
  _User___preview?: Maybe<Gql_User>;
  /**
   * Validation of a create on object of class Todo.
   * Returns a ValidationResult.
   */
  Todo___validateCreate?: Maybe<GqlValidationResult>;
  /**
   * Validation of a create on object of class _User.
   * Returns a ValidationResult.
   */
  _User___validateCreate?: Maybe<GqlValidationResult>;
  /** Retrieve a preview object of class Todo for an object of Todo not yet instanced. */
  Todo___previewCreate?: Maybe<GqlTodo>;
  /** Retrieve a preview object of class _User for an object of _User not yet instanced. */
  _User___previewCreate?: Maybe<Gql_User>;
  /**
   * Validation of a delete on object of class Todo.
   * Returns a ValidationResult.
   */
  Todo___validateDelete?: Maybe<GqlValidationResult>;
  /**
   * Validation of a bulk delete on a set of objects of class Todo.
   * Returns a ValidationResult.
   */
  Todo___validateDeleteBulk?: Maybe<GqlValidationResult>;
  /**
   * Validation of a delete on object of class _User.
   * Returns a ValidationResult.
   */
  _User___validateDelete?: Maybe<GqlValidationResult>;
  /**
   * Validation of a bulk delete on a set of objects of class _User.
   * Returns a ValidationResult.
   */
  _User___validateDeleteBulk?: Maybe<GqlValidationResult>;
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___getArgs {
  _id: Scalars['ID'];
  insight?: Maybe<GqlInsightType>;
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___getPageArgs {
  options?: Maybe<GqlTodoPageOptions>;
  insight?: Maybe<GqlInsightType>;
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___getArgs {
  _id: Scalars['ID'];
  insight?: Maybe<GqlInsightType>;
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___getPageArgs {
  options?: Maybe<Gql_UserPageOptions>;
  insight?: Maybe<GqlInsightType>;
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___previewUpdateArgs {
  data: GqlTodoDraftUpdate;
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___previewUpdateArgs {
  data: Gql_UserDraftUpdate;
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___validateUpdateArgs {
  data: GqlTodoDraftUpdate;
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___validateUpdateBulkArgs {
  data: GqlTodoDraftUpdateBulk;
  options: GqlTodoPageOptions;
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___validateUpdateArgs {
  data: Gql_UserDraftUpdate;
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___validateUpdateBulkArgs {
  data: Gql_UserDraftUpdateBulk;
  options: Gql_UserPageOptions;
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___validateArgs {
  data: GqlTodoDraft;
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___validateArgs {
  data: Gql_UserDraft;
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___previewArgs {
  data: GqlTodoDraft;
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___previewArgs {
  data: Gql_UserDraft;
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___validateCreateArgs {
  data: GqlTodoDraftCreate;
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___validateCreateArgs {
  data: Gql_UserDraftCreate;
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___previewCreateArgs {
  data: GqlTodoDraftCreate;
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___previewCreateArgs {
  data: Gql_UserDraftCreate;
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___validateDeleteArgs {
  _id: Scalars['ID'];
}


/** Use a Query to fetch data. */
export interface GqlQueryTodo___validateDeleteBulkArgs {
  options: GqlTodoPageOptions;
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___validateDeleteArgs {
  _id: Scalars['ID'];
}


/** Use a Query to fetch data. */
export interface GqlQuery_User___validateDeleteBulkArgs {
  options: Gql_UserPageOptions;
}





/** Represents an object of class Todo, as defined in the model. */
export interface GqlTodo {
  /**
   * A special attribute, choosen by the client, useful to
   * uniquely reference not existing objects.
   */
  _clientId?: Maybe<Scalars['ID']>;
  /** The attribute _createdby of Todo. It is of type String. Cannot be null. */
  _createdby?: Maybe<Scalars['String']>;
  /** The attribute _id of Todo. It is of type ID. Cannot be null. */
  _id?: Maybe<Scalars['ID']>;
  /** The attribute completed of Todo. It is of type Boolean.  */
  completed?: Maybe<Scalars['Boolean']>;
  /** The attribute description of Todo. It is of type Text.  */
  description?: Maybe<Scalars['Text']>;
  /** The attribute due_date of Todo. It is of type Date @dateFormat.  */
  due_date?: Maybe<Scalars['Date']>;
  /** The attribute title of Todo. It is of type String. Max length: 255.  */
  title?: Maybe<Scalars['String']>;
}


/** Represents an object of class Todo, as defined in the model. */
export interface GqlTododue_dateArgs {
  format?: Maybe<Scalars['String']>;
}

/** The result of the Todo___updateBulk mutation on objects of class Todo. */
export interface GqlTodoBulkResult {
  /** An array of objects of class Todo affected by the mutation. */
  items: Array<GqlTodo>;
  /** The total count of objects affected by the mutation, */
  totalCount: Scalars['Int'];
}

/** A data structure for objects of Todo. */
export interface GqlTodoCreate {
  /**
   * A special attribute, choosen by the client, useful to
   * uniquely reference not existing objects.
   */
  _clientId?: Maybe<Scalars['ID']>;
  /** The attribute completed of Todo. It is of type Boolean.  */
  completed?: Maybe<Scalars['Boolean']>;
  /** The attribute description of Todo. It is of type Text.  */
  description?: Maybe<Scalars['Text']>;
  /** The attribute due_date of Todo. It is of type Date.  */
  due_date?: Maybe<Scalars['Date']>;
  /** The attribute title of Todo. It is of type String. Max length: 255.  */
  title?: Maybe<Scalars['String']>;
}

/**
 * Define a specific [Cursor](https://en.wikipedia.org/wiki/Cursor_%28databases%29) for objects of type
 * Todo.
 */
export interface GqlTodoCursor {
  _createdby?: Maybe<Scalars['String']>;
  _id?: Maybe<Scalars['ID']>;
  completed?: Maybe<Scalars['Boolean']>;
  description?: Maybe<Scalars['Text']>;
  due_date?: Maybe<Scalars['Date']>;
  title?: Maybe<Scalars['String']>;
}

/** A data structure for a draft object of class Todo. */
export interface GqlTodoDraft {
  _id?: Maybe<Scalars['ID']>;
  /**
   * A special attribute, choosen by the client, useful to
   * uniquely reference not existing objects.
   */
  _clientId?: Maybe<Scalars['ID']>;
  /** The attribute completed of Todo. It is of type Boolean.  */
  completed?: Maybe<Scalars['Boolean']>;
  /** The attribute description of Todo. It is of type Text.  */
  description?: Maybe<Scalars['Text']>;
  /** The attribute due_date of Todo. It is of type Date.  */
  due_date?: Maybe<Scalars['Date']>;
  /** The attribute title of Todo. It is of type String. Max length: 255.  */
  title?: Maybe<Scalars['String']>;
}

/** A data structure for draft create objects of class Todo. */
export interface GqlTodoDraftCreate {
  /**
   * A special attribute, choosen by the client, useful to
   * uniquely reference not existing objects.
   */
  _clientId?: Maybe<Scalars['ID']>;
  /** The attribute completed of Todo. It is of type Boolean.  */
  completed?: Maybe<Scalars['Boolean']>;
  /** The attribute description of Todo. It is of type Text.  */
  description?: Maybe<Scalars['Text']>;
  /** The attribute due_date of Todo. It is of type Date.  */
  due_date?: Maybe<Scalars['Date']>;
  /** The attribute title of Todo. It is of type String. Max length: 255.  */
  title?: Maybe<Scalars['String']>;
}

/** A data structure for a draft update object of class Todo. */
export interface GqlTodoDraftUpdate {
  _id: Scalars['ID'];
  /** The attribute completed of Todo. It is of type Boolean.  */
  completed?: Maybe<Scalars['Boolean']>;
  /** The attribute description of Todo. It is of type Text.  */
  description?: Maybe<Scalars['Text']>;
  /** The attribute due_date of Todo. It is of type Date.  */
  due_date?: Maybe<Scalars['Date']>;
  /** The attribute title of Todo. It is of type String. Max length: 255.  */
  title?: Maybe<Scalars['String']>;
}

/** A data structure for a draft update objects of class Todo. */
export interface GqlTodoDraftUpdateBulk {
  /** The attribute completed of Todo. It is of type Boolean.  */
  completed?: Maybe<Scalars['Boolean']>;
  /** The attribute description of Todo. It is of type Text.  */
  description?: Maybe<Scalars['Text']>;
  /** The attribute due_date of Todo. It is of type Date.  */
  due_date?: Maybe<Scalars['Date']>;
  /** The attribute title of Todo. It is of type String. Max length: 255.  */
  title?: Maybe<Scalars['String']>;
}

/**
 * Define a specific filter for objects of type Todo.
 * Each attribute can be filtered in different ways (depending on the type of the attribute).
 * Filters can be composed with the boolan operators AND, OR and NOT.
 */
export interface GqlTodoFilter {
  _clientId___eq?: Maybe<Scalars['ID']>;
  _createdby___eq?: Maybe<Scalars['String']>;
  _createdby___ne?: Maybe<Scalars['String']>;
  _createdby___null?: Maybe<Scalars['Boolean']>;
  _createdby___not___null?: Maybe<Scalars['Boolean']>;
  _createdby___in?: Maybe<Array<Scalars['String']>>;
  _createdby___not___in?: Maybe<Array<Scalars['String']>>;
  _createdby___lt?: Maybe<Scalars['String']>;
  _createdby___lte?: Maybe<Scalars['String']>;
  _createdby___gt?: Maybe<Scalars['String']>;
  _createdby___gte?: Maybe<Scalars['String']>;
  _createdby___contains?: Maybe<Scalars['String']>;
  _createdby___not___contains?: Maybe<Scalars['String']>;
  _createdby___starts_with?: Maybe<Scalars['String']>;
  _createdby___not___starts_with?: Maybe<Scalars['String']>;
  _createdby___ends_with?: Maybe<Scalars['String']>;
  _createdby___not___ends_with?: Maybe<Scalars['String']>;
  _id___eq?: Maybe<Scalars['ID']>;
  _id___ne?: Maybe<Scalars['ID']>;
  _id___null?: Maybe<Scalars['Boolean']>;
  _id___not___null?: Maybe<Scalars['Boolean']>;
  _id___in?: Maybe<Array<Maybe<Scalars['ID']>>>;
  _id___not___in?: Maybe<Array<Scalars['ID']>>;
  _id___lt?: Maybe<Scalars['ID']>;
  _id___lte?: Maybe<Scalars['ID']>;
  _id___gt?: Maybe<Scalars['ID']>;
  _id___gte?: Maybe<Scalars['ID']>;
  completed___eq?: Maybe<Scalars['Boolean']>;
  completed___ne?: Maybe<Scalars['Boolean']>;
  completed___null?: Maybe<Scalars['Boolean']>;
  completed___not___null?: Maybe<Scalars['Boolean']>;
  description___eq?: Maybe<Scalars['Text']>;
  description___ne?: Maybe<Scalars['Text']>;
  description___null?: Maybe<Scalars['Boolean']>;
  description___not___null?: Maybe<Scalars['Boolean']>;
  description___in?: Maybe<Array<Scalars['Text']>>;
  description___not___in?: Maybe<Array<Scalars['Text']>>;
  description___lt?: Maybe<Scalars['Text']>;
  description___lte?: Maybe<Scalars['Text']>;
  description___gt?: Maybe<Scalars['Text']>;
  description___gte?: Maybe<Scalars['Text']>;
  description___contains?: Maybe<Scalars['Text']>;
  description___not___contains?: Maybe<Scalars['Text']>;
  description___starts_with?: Maybe<Scalars['Text']>;
  description___not___starts_with?: Maybe<Scalars['Text']>;
  description___ends_with?: Maybe<Scalars['Text']>;
  description___not___ends_with?: Maybe<Scalars['Text']>;
  due_date___eq?: Maybe<Scalars['Date']>;
  due_date___ne?: Maybe<Scalars['Date']>;
  due_date___null?: Maybe<Scalars['Boolean']>;
  due_date___not___null?: Maybe<Scalars['Boolean']>;
  due_date___in?: Maybe<Array<Maybe<Scalars['Date']>>>;
  due_date___not___in?: Maybe<Array<Scalars['Date']>>;
  due_date___lt?: Maybe<Scalars['Date']>;
  due_date___lte?: Maybe<Scalars['Date']>;
  due_date___gt?: Maybe<Scalars['Date']>;
  due_date___gte?: Maybe<Scalars['Date']>;
  title___eq?: Maybe<Scalars['String']>;
  title___ne?: Maybe<Scalars['String']>;
  title___null?: Maybe<Scalars['Boolean']>;
  title___not___null?: Maybe<Scalars['Boolean']>;
  title___in?: Maybe<Array<Scalars['String']>>;
  title___not___in?: Maybe<Array<Scalars['String']>>;
  title___lt?: Maybe<Scalars['String']>;
  title___lte?: Maybe<Scalars['String']>;
  title___gt?: Maybe<Scalars['String']>;
  title___gte?: Maybe<Scalars['String']>;
  title___contains?: Maybe<Scalars['String']>;
  title___not___contains?: Maybe<Scalars['String']>;
  title___starts_with?: Maybe<Scalars['String']>;
  title___not___starts_with?: Maybe<Scalars['String']>;
  title___ends_with?: Maybe<Scalars['String']>;
  title___not___ends_with?: Maybe<Scalars['String']>;
  AND?: Maybe<Array<GqlTodoFilter>>;
  OR?: Maybe<Array<GqlTodoFilter>>;
  NOT?: Maybe<GqlTodoFilter>;
}

/** Represents a collection of objects of class Todo. */
export interface GqlTodoPage {
  /** An array containing the actual objects of class Todo. */
  items: Array<GqlTodo>;
  /** The total number of objects of class Todo present in the database. */
  totalCount: Scalars['Int'];
  /** A cursor to the next object, used to iterate over the elements. */
  nextCursor?: Maybe<Scalars['Cursor']>;
  /** A cursor to the previous object, used to iterate over the elements in reverse order. */
  prevCursor?: Maybe<Scalars['Cursor']>;
  /** A boolan flag that indicates if there are more elements following the ones retrieved. */
  hasNext: Scalars['Boolean'];
  /** A boolan flag that indicates if there are elements preceding the ones retrieved. */
  hasPrev: Scalars['Boolean'];
}

/** Options to configure the list of elements to be returned by a TodoPage. */
export interface GqlTodoPageOptions {
  /** Used to filter the data to retrieve. */
  filter?: Maybe<GqlTodoFilter>;
  /** Used to filter the data to retrieve. The filter is expressed using the LiveBase language. */
  filter_exp?: Maybe<Scalars['String']>;
  /** Used to skip the first objects. */
  offset?: Maybe<Scalars['Int']>;
  /** Used to retrieve the object following an existing Cursor. */
  cursor?: Maybe<Scalars['Cursor']>;
  /** Used to retrieve objects from a specific cursor. */
  fromCursor?: Maybe<GqlTodoCursor>;
  /** Used to set the number of items returned by the page. */
  next?: Maybe<Scalars['Int']>;
  /** Used to set the number of items returned by the page. */
  prev?: Maybe<Scalars['Int']>;
  /** Used to set the ordering of the items returned by the page. */
  orderBy?: Maybe<Array<GqlTodoSort>>;
}

/** Specify if an ordering should be applied ascending or descending. */
export enum GqlTodoSort {
  _createdby___ASC = '_createdby___ASC',
  _createdby___DESC = '_createdby___DESC',
  _id___ASC = '_id___ASC',
  _id___DESC = '_id___DESC',
  completed___ASC = 'completed___ASC',
  completed___DESC = 'completed___DESC',
  description___ASC = 'description___ASC',
  description___DESC = 'description___DESC',
  due_date___ASC = 'due_date___ASC',
  due_date___DESC = 'due_date___DESC',
  title___ASC = 'title___ASC',
  title___DESC = 'title___DESC'
}

/** A data structure for a single object of class Todo. */
export interface GqlTodoUpdate {
  _id: Scalars['ID'];
  /** The attribute completed of Todo. It is of type Boolean.  */
  completed?: Maybe<Scalars['Boolean']>;
  /** The attribute description of Todo. It is of type Text.  */
  description?: Maybe<Scalars['Text']>;
  /** The attribute due_date of Todo. It is of type Date.  */
  due_date?: Maybe<Scalars['Date']>;
  /** The attribute title of Todo. It is of type String. Max length: 255.  */
  title?: Maybe<Scalars['String']>;
}

/** A data structure for objects of class Todo. */
export interface GqlTodoUpdateBulk {
  /** The attribute completed of Todo. It is of type Boolean.  */
  completed?: Maybe<Scalars['Boolean']>;
  /** The attribute description of Todo. It is of type Text.  */
  description?: Maybe<Scalars['Text']>;
  /** The attribute due_date of Todo. It is of type Date.  */
  due_date?: Maybe<Scalars['Date']>;
  /** The attribute title of Todo. It is of type String. Max length: 255.  */
  title?: Maybe<Scalars['String']>;
}

/** The result of the validate services. */
export interface GqlValidationResult {
  isValid: Scalars['Boolean'];
  issues: Array<GqlIssue>;
}


/** Represents an object of class _User, as defined in the model. */
export interface Gql_User {
  /**
   * A special attribute, choosen by the client, useful to
   * uniquely reference not existing objects.
   */
  _clientId?: Maybe<Scalars['ID']>;
  /** The attribute _id of _User. It is of type ID. Cannot be null. */
  _id?: Maybe<Scalars['ID']>;
  /** The attribute email of _User. It is of type String. Max length: 255. Cannot be null. */
  email?: Maybe<Scalars['String']>;
  /**
   * The attribute profile of _User. It is of type String. Domain: .
   * Max length: 255. Cannot be null.
   */
  profile?: Maybe<Scalars['String']>;
  /** The attribute username of _User. It is of type String. Max length: 255. Cannot be null. */
  username?: Maybe<Scalars['String']>;
}

/** The result of the _User___updateBulk mutation on objects of class _User. */
export interface Gql_UserBulkResult {
  /** An array of objects of class _User affected by the mutation. */
  items: Array<Gql_User>;
  /** The total count of objects affected by the mutation, */
  totalCount: Scalars['Int'];
}

/** A data structure for objects of _User. */
export interface Gql_UserCreate {
  /**
   * A special attribute, choosen by the client, useful to
   * uniquely reference not existing objects.
   */
  _clientId?: Maybe<Scalars['ID']>;
  /** The attribute email of _User. It is of type String!. Max length: 255. Cannot be null. */
  email: Scalars['String'];
  /**
   * The attribute profile of _User. It is of type String!. Domain: .
   * Max length: 255. Cannot be null.
   */
  profile: Scalars['String'];
  /** The attribute username of _User. It is of type String!. Max length: 255. Cannot be null. */
  username: Scalars['String'];
}

/**
 * Define a specific [Cursor](https://en.wikipedia.org/wiki/Cursor_%28databases%29) for objects of type
 * _User.
 */
export interface Gql_UserCursor {
  _id?: Maybe<Scalars['ID']>;
  email?: Maybe<Scalars['String']>;
  profile?: Maybe<Scalars['String']>;
  username?: Maybe<Scalars['String']>;
}

/** A data structure for a draft object of class _User. */
export interface Gql_UserDraft {
  _id?: Maybe<Scalars['ID']>;
  /**
   * A special attribute, choosen by the client, useful to
   * uniquely reference not existing objects.
   */
  _clientId?: Maybe<Scalars['ID']>;
  /** The attribute email of _User. It is of type String. Max length: 255. Cannot be null. */
  email?: Maybe<Scalars['String']>;
  /**
   * The attribute profile of _User. It is of type String. Domain: .
   * Max length: 255. Cannot be null.
   */
  profile?: Maybe<Scalars['String']>;
  /** The attribute username of _User. It is of type String. Max length: 255. Cannot be null. */
  username?: Maybe<Scalars['String']>;
}

/** A data structure for draft create objects of class _User. */
export interface Gql_UserDraftCreate {
  /**
   * A special attribute, choosen by the client, useful to
   * uniquely reference not existing objects.
   */
  _clientId?: Maybe<Scalars['ID']>;
  /** The attribute email of _User. It is of type String. Max length: 255. Cannot be null. */
  email?: Maybe<Scalars['String']>;
  /**
   * The attribute profile of _User. It is of type String. Domain: .
   * Max length: 255. Cannot be null.
   */
  profile?: Maybe<Scalars['String']>;
  /** The attribute username of _User. It is of type String. Max length: 255. Cannot be null. */
  username?: Maybe<Scalars['String']>;
}

/** A data structure for a draft update object of class _User. */
export interface Gql_UserDraftUpdate {
  _id: Scalars['ID'];
  /** The attribute email of _User. It is of type String. Max length: 255. Cannot be null. */
  email?: Maybe<Scalars['String']>;
  /**
   * The attribute profile of _User. It is of type String. Domain: .
   * Max length: 255. Cannot be null.
   */
  profile?: Maybe<Scalars['String']>;
  /** The attribute username of _User. It is of type String. Max length: 255. Cannot be null. */
  username?: Maybe<Scalars['String']>;
}

/** A data structure for a draft update objects of class _User. */
export interface Gql_UserDraftUpdateBulk {
  /** The attribute email of _User. It is of type String. Max length: 255. Cannot be null. */
  email?: Maybe<Scalars['String']>;
  /**
   * The attribute profile of _User. It is of type String. Domain: .
   * Max length: 255. Cannot be null.
   */
  profile?: Maybe<Scalars['String']>;
  /** The attribute username of _User. It is of type String. Max length: 255. Cannot be null. */
  username?: Maybe<Scalars['String']>;
}

/**
 * Define a specific filter for objects of type _User.
 * Each attribute can be filtered in different ways (depending on the type of the attribute).
 * Filters can be composed with the boolan operators AND, OR and NOT.
 */
export interface Gql_UserFilter {
  _clientId___eq?: Maybe<Scalars['ID']>;
  _id___eq?: Maybe<Scalars['ID']>;
  _id___ne?: Maybe<Scalars['ID']>;
  _id___null?: Maybe<Scalars['Boolean']>;
  _id___not___null?: Maybe<Scalars['Boolean']>;
  _id___in?: Maybe<Array<Maybe<Scalars['ID']>>>;
  _id___not___in?: Maybe<Array<Scalars['ID']>>;
  _id___lt?: Maybe<Scalars['ID']>;
  _id___lte?: Maybe<Scalars['ID']>;
  _id___gt?: Maybe<Scalars['ID']>;
  _id___gte?: Maybe<Scalars['ID']>;
  email___eq?: Maybe<Scalars['String']>;
  email___ne?: Maybe<Scalars['String']>;
  email___null?: Maybe<Scalars['Boolean']>;
  email___not___null?: Maybe<Scalars['Boolean']>;
  email___in?: Maybe<Array<Scalars['String']>>;
  email___not___in?: Maybe<Array<Scalars['String']>>;
  email___lt?: Maybe<Scalars['String']>;
  email___lte?: Maybe<Scalars['String']>;
  email___gt?: Maybe<Scalars['String']>;
  email___gte?: Maybe<Scalars['String']>;
  email___contains?: Maybe<Scalars['String']>;
  email___not___contains?: Maybe<Scalars['String']>;
  email___starts_with?: Maybe<Scalars['String']>;
  email___not___starts_with?: Maybe<Scalars['String']>;
  email___ends_with?: Maybe<Scalars['String']>;
  email___not___ends_with?: Maybe<Scalars['String']>;
  profile___eq?: Maybe<Scalars['String']>;
  profile___ne?: Maybe<Scalars['String']>;
  profile___null?: Maybe<Scalars['Boolean']>;
  profile___not___null?: Maybe<Scalars['Boolean']>;
  profile___in?: Maybe<Array<Scalars['String']>>;
  profile___not___in?: Maybe<Array<Scalars['String']>>;
  profile___lt?: Maybe<Scalars['String']>;
  profile___lte?: Maybe<Scalars['String']>;
  profile___gt?: Maybe<Scalars['String']>;
  profile___gte?: Maybe<Scalars['String']>;
  profile___contains?: Maybe<Scalars['String']>;
  profile___not___contains?: Maybe<Scalars['String']>;
  profile___starts_with?: Maybe<Scalars['String']>;
  profile___not___starts_with?: Maybe<Scalars['String']>;
  profile___ends_with?: Maybe<Scalars['String']>;
  profile___not___ends_with?: Maybe<Scalars['String']>;
  username___eq?: Maybe<Scalars['String']>;
  username___ne?: Maybe<Scalars['String']>;
  username___null?: Maybe<Scalars['Boolean']>;
  username___not___null?: Maybe<Scalars['Boolean']>;
  username___in?: Maybe<Array<Scalars['String']>>;
  username___not___in?: Maybe<Array<Scalars['String']>>;
  username___lt?: Maybe<Scalars['String']>;
  username___lte?: Maybe<Scalars['String']>;
  username___gt?: Maybe<Scalars['String']>;
  username___gte?: Maybe<Scalars['String']>;
  username___contains?: Maybe<Scalars['String']>;
  username___not___contains?: Maybe<Scalars['String']>;
  username___starts_with?: Maybe<Scalars['String']>;
  username___not___starts_with?: Maybe<Scalars['String']>;
  username___ends_with?: Maybe<Scalars['String']>;
  username___not___ends_with?: Maybe<Scalars['String']>;
  AND?: Maybe<Array<Gql_UserFilter>>;
  OR?: Maybe<Array<Gql_UserFilter>>;
  NOT?: Maybe<Gql_UserFilter>;
}

/** Represents a collection of objects of class _User. */
export interface Gql_UserPage {
  /** An array containing the actual objects of class _User. */
  items: Array<Gql_User>;
  /** The total number of objects of class _User present in the database. */
  totalCount: Scalars['Int'];
  /** A cursor to the next object, used to iterate over the elements. */
  nextCursor?: Maybe<Scalars['Cursor']>;
  /** A cursor to the previous object, used to iterate over the elements in reverse order. */
  prevCursor?: Maybe<Scalars['Cursor']>;
  /** A boolan flag that indicates if there are more elements following the ones retrieved. */
  hasNext: Scalars['Boolean'];
  /** A boolan flag that indicates if there are elements preceding the ones retrieved. */
  hasPrev: Scalars['Boolean'];
}

/** Options to configure the list of elements to be returned by a _UserPage. */
export interface Gql_UserPageOptions {
  /** Used to filter the data to retrieve. */
  filter?: Maybe<Gql_UserFilter>;
  /** Used to filter the data to retrieve. The filter is expressed using the LiveBase language. */
  filter_exp?: Maybe<Scalars['String']>;
  /** Used to skip the first objects. */
  offset?: Maybe<Scalars['Int']>;
  /** Used to retrieve the object following an existing Cursor. */
  cursor?: Maybe<Scalars['Cursor']>;
  /** Used to retrieve objects from a specific cursor. */
  fromCursor?: Maybe<Gql_UserCursor>;
  /** Used to set the number of items returned by the page. */
  next?: Maybe<Scalars['Int']>;
  /** Used to set the number of items returned by the page. */
  prev?: Maybe<Scalars['Int']>;
  /** Used to set the ordering of the items returned by the page. */
  orderBy?: Maybe<Array<Gql_UserSort>>;
}

/** Specify if an ordering should be applied ascending or descending. */
export enum Gql_UserSort {
  _id___ASC = '_id___ASC',
  _id___DESC = '_id___DESC',
  email___ASC = 'email___ASC',
  email___DESC = 'email___DESC',
  profile___ASC = 'profile___ASC',
  profile___DESC = 'profile___DESC',
  username___ASC = 'username___ASC',
  username___DESC = 'username___DESC'
}

/** A data structure for a single object of class _User. */
export interface Gql_UserUpdate {
  _id: Scalars['ID'];
  /** The attribute email of _User. It is of type String. Max length: 255. Cannot be null. */
  email?: Maybe<Scalars['String']>;
  /**
   * The attribute profile of _User. It is of type String. Domain: .
   * Max length: 255. Cannot be null.
   */
  profile?: Maybe<Scalars['String']>;
  /** The attribute username of _User. It is of type String. Max length: 255. Cannot be null. */
  username?: Maybe<Scalars['String']>;
}

/** A data structure for objects of class _User. */
export interface Gql_UserUpdateBulk {
  /** The attribute email of _User. It is of type String. Max length: 255. Cannot be null. */
  email?: Maybe<Scalars['String']>;
  /**
   * The attribute profile of _User. It is of type String. Domain: .
   * Max length: 255. Cannot be null.
   */
  profile?: Maybe<Scalars['String']>;
  /** The attribute username of _User. It is of type String. Max length: 255. Cannot be null. */
  username?: Maybe<Scalars['String']>;
}
