import gql from "graphql-tag";

const _Todo = gql`
	fragment _Todo on Todo {
		_clientId
		_objectTitle: title
		_createdby 
		_id 
		completed 
		description 
		due_date 
		title 
	}`;

export const GET_Todo = gql`
	query GET_Todo($id: ID!) {
		result: Todo___get(_id: $id) {
			..._Todo
		}
	}
	${_Todo}`;

export const GET_PAGE_Todo = gql`
	query GET_PAGE_Todo(
		$options: TodoPageOptions = { offset:0, next:10, orderBy:[_id___ASC] },
		$withTotalCount: Boolean = false
	) {				
		result: Todo___getPage(options: $options) {
			totalCount @include(if: $withTotalCount)
			hasNext
			nextCursor
			hasPrev
			prevCursor
			items { 
				..._Todo
			}
		}
	}
	${_Todo}`;

export const SAVE_Todo = gql`
	mutation SAVE_Todo(
		$data: TodoDraft!, 
		$forceWarnings: ForceWarnings = {actionVeto: false, dataValidation: false}
	) {
		result: Todo___save(data: $data, forceWarnings: $forceWarnings) {
			..._Todo
		}
	}
	${_Todo}`;

export const DELETE_Todo = gql`
	mutation DELETE_Todo(
		$id: ID!,
		$forceWarnings: ForceWarnings = {actionVeto: false, dataValidation: false}
	) {
		result: Todo___delete(_id: $id, forceWarnings: $forceWarnings) {
			deleted
		}
	}`;
