import Vue from 'vue'
import VueRouter, { RouteConfig } from 'vue-router'
import TodoList from '../views/TodoList.vue'
import Login from '../views/Login.vue'


Vue.use(VueRouter)

export const loginRoute = {
  path: '/login',
  name: 'Login',
  component: Login
}

export const homeRoute = {
  path: '/home',
  name: 'Home',
  component: TodoList
}

const routes: Array<RouteConfig> = [
  loginRoute,
  homeRoute,
  {
    // will match everything
    path: "*",
    redirect: loginRoute
  }
]

const router = new VueRouter({
  mode: 'history',
  base: process.env.BASE_URL,
  routes
})


export default router
